/*
** $Id: ldumplib.c,v 1.6a 2002/02/28 20:09:28 lhf Exp $
** library access to precompiler
** See Copyright Notice in lua.h
*/

#include "lua.h"
#include "lualib.h"
#include "lauxlib.h"

#define FILE			luaL_Buffer
#define fwrite(b,size,n,D)	luaL_addlstring(D,(void*)b,(size)*(n))
#define fputc(c,D)		luaL_putchar(D,c)
#define fputs(s,D)		luaL_addlstring(D,""s,sizeof(s)-1)
#define LDUMPLIB
#include "dump.c"

static int dump(lua_State *L) {
 if (!lua_isfunction(L,1)) {
  luaL_argerror(L,1,"Lua function expected");
  return 0;
 }
 else if (lua_iscfunction(L,1)) {
  luaL_argerror(L,1,"cannot dump C functions");
  return 0;
 }
 else {
  luaL_Buffer b;
  const Closure* c=lua_topointer(L,1);
  if (c->nupvalues>0) luaL_argerror(L,1,"cannot dump closures");
  luaL_buffinit(L,&b);
  luaU_dumpchunk(c->f.l,&b);
  luaL_pushresult(&b);
  return 1;
 }
}

/*
** Open dump library
*/
LUALIB_API int lua_dumplibopen (lua_State *L) {
 lua_register(L,"dump",dump);
 return 0;
}
